// CreateUrl.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

using namespace std;

/******************************************************************
 CreateUrl - Creates a shortcut via IUniformResourceLocatorW

*******************************************************************/
static HRESULT CreateUrl(
	__in LPCWSTR wzTarget,
	__in LPCWSTR wzShortcutPath
	)
{
	HRESULT hr = S_OK;
	IUniformResourceLocatorW* piURL = NULL;
	IPersistFile* piPersistFile = NULL;
	hr = ::CoInitialize(NULL);
	
	if(hr!=0)
	{
		cout<<"failed to initialize COM\n";
		return hr;
	}
	
	// create an internet shortcut object
	cout << "Creating IUniformResourceLocatorW shortcut\n";
	hr = ::CoCreateInstance(CLSID_InternetShortcut, NULL, CLSCTX_ALL, IID_IUniformResourceLocatorW, (void**)&piURL);
	
	if (hr!=0)
	{
		cout<<"failed to create an instance of IUniformResourceLocatorW";
		return hr;
	}
	// set shortcut target
	hr = piURL->SetURL(wzTarget, 0);
	
	if (hr!=0)
	{
		cout << "failed to set shortcut \n";
		return hr;
	}

// get an IPersistFile and save the shortcut
	hr = piURL->QueryInterface(IID_IPersistFile, (void**)&piPersistFile);
	
	if (hr!=0)
	{
		cout << "failed to get IPersistFile for shortcut \n";
		return hr;
	}
	
	hr = piPersistFile->Save(wzShortcutPath, TRUE);
	
	if (hr!=0)
	{
		cout << "failed to save shortcut  \n";
		return hr;
	}

	cout << "Created shortcut \n";
	return hr;
}

int _tmain(int argc, _TCHAR* argv[])
{
	int result=CreateUrl(L"http://www.telerik.com/",L"c:\\TelerikShortcut.url");
	
	if(result!=0)
		cout << "Error Code: " << result;
	
	return result;
}